module MRobot ( 
   Color, Mapa, Robot, 
   getBlanc, getBlau, getGroc, getVerd, getVermell,
   esBlanc, esBlau, esGroc, esVerd, esVermell,
   ampladaMapa, alturaMapa,
   teColor, obtenirColor, teCartutx, obtenirColorCartutx, 
   esPinta, esPintaDis, colorPinta,
   activarPintar,desactivarPintar,activarPintarDis,desactivarPintarDis,
   obtenirPos, gUp, gDown, gRight, gLeft, avanca, 
   canviaBlanc, canviaBlau, canviaGroc, canviaVerd, canviaVermell,
   mapaIni, robotInici) where

data Color = ...
data  Mapa = ...
data Robot = ..

-- constant que és el color Blanc
getBlanc :: Color

-- constant que és el color Blau
getBlau :: Color

-- constant que és el color Groc
getGroc :: Color

-- constant que és el color Verd
getVerd :: Color

-- constant que és el color Vermell
getVermell :: Color

-- les següents funcions indiquen el color que es.
esBlanc :: Color -> Bool
esBlau :: Color -> Bool
esGroc :: Color -> Bool
esVerd :: Color -> Bool
esVermell :: Color -> Bool

--retorna l'amplada del mapa (nombre de caselles)
ampladaMapa :: Mapa -> Int

--retorna l'altura del mapa (nombre de caselles)
alturaMapa :: Mapa -> Int

-- indica si la casella del mapa esta pintada
teColor :: Mapa -> Int -> Int -> Bool 

-- retorna el color de la casella del mapa (assumeix que esta pintada)
obtenirColor :: Mapa -> Int -> Int -> Color 

-- indica si la casella del mapa conte un cartutx
teCartutx :: Mapa -> Int -> Int -> Bool

-- retorna el color del cartutx de la casella del mapa (assumeix que te cartutx)
obtenirColorCartutx :: Mapa -> Int -> Int -> Color 

-- indica si l'acció activa es pintar discontiament
esPintaDis:: Robot -> Bool

-- indica si l'acció activa es pintar
esPinta:: Robot -> Bool

-- indica quin color està actiu. Podeu assumir que es sap que pinta o pinta disc
colorPinta:: Robot -> Color

-- activa l'opcio de pintar del robot
activarPintar :: Robot -> Robot

-- desactiva l'opcio de pintar del robot
desactivarPintar :: Robot -> Robot

-- activa l'opcio de pintar discontinu del robot
activarPintarDis :: Robot -> Robot

-- desactiva l'opcio de pintar discontinu del robot
desactivarPintarDis :: Robot -> Robot

-- retorna la posició del robot en forma de parell 
obtenirPos :: Robot -> (Int,Int)

-- posa l'orientacio del robot a Up
gUp :: Robot -> Robot

-- posa l'orientacio del robot a Down
gDown :: Robot -> Robot

-- posa l'orientacio del robot a Right
gRight :: Robot -> Robot

-- posa l'orientacio del robot a Left
gLeft :: Robot -> Robot

-- avanca el robot si es possible i modifica el mapa 
avanca :: Robot -> Mapa -> (Robot,Mapa)

-- les següents funcions canvien el color del robot.
canviaBlanc :: Robot -> Robot
canviaBlau  :: Robot -> Robot
canviaGroc  :: Robot -> Robot
canviaVerd  :: Robot -> Robot
canviaVermell :: Robot -> Robot

-- mapa inicial
mapaIni :: Mapa

-- robot inicial
robotInici :: Robot
